function dump_emmsimple(data,C,dim,where,offset)
% data is feature dataset
% C ... number of components
% dim ... dimensionality
% where ... dump directory
    flist = fopen(fullfile(where,'filelist.txt'),'at');
    for i=1:length(data)
        fprintf(flist,'model%d\n',i+offset-1);
         if (isempty(data{i}))
            data{i}.PComponents = zeros(1,C);
            for k=1:C
                data{i}.Sigma(1,:,k) = zeros(1,dim);
                data{i}.mu(k,:) = zeros(1,dim);
            end
        end
        % get component weighs and write to file 
        pi = data{i}.PComponents;
        pistr = sprintf('model%d.pi',i+offset-1);
        fidpi = fopen(fullfile(where,pistr),'wb');
        fwrite(fidpi,pi,'double');
        fclose(fidpi);
        % iterate over all components and write to file
        for j=1:C
            mu = data{i}.mu(j,:);
            %cov = diag(data{i}.Sigma(:,:,j));
            cov = data{i}.Sigma(:,:,j); % diagonal elements (diagonal matrix)
            mustr = sprintf('model%d.%d.mu',i+offset-1,j-1);
            Cstr = sprintf('model%d.%d.cov',i+offset-1,j-1);
            fidmu = fopen(fullfile(where,mustr),'wb');
            fidcov = fopen(fullfile(where,Cstr),'wb');
            fwrite(fidmu,mu,'double');
            fwrite(fidcov,cov,'double');
            fclose(fidmu);
            fclose(fidcov);
        end
    end
    fclose(flist);
end
